read req
# Handle the request line
method="`echo "$req" | awk '{ print $1 }'`"
file="`echo "$req" | awk '{ print $2 }'`"
protocol="`echo "$req" | awk '{ print $3 }'`"

# Handle GET
query_string="`echo "$file" | sed -n -e "/?/{s/.*?//;p;}"`"
file="/`echo "$file" | sed -e "/?/{s/?.*//;}"`/"

# Read remaining headers until empty line
# headers="`cat << ""`"
headers=""
header="..."
while [ "$header" != "" -a "$header" != "
" ] && read header; do
headers="`echo "${header}" | sed -e "s/\r/\n/g;"`
${headers}"
done

while echo "$file" | grep "/\./" > /dev/null; do
  file="`echo "$file" | sed -e "s/\/\.\//\//g;"`"
done
while echo "$file" | grep "/\.\./" > /dev/null; do
  file="`echo "$file" | sed -e "s/\/[^\/]*\/\.\.\//\//g;"`"
done
file="`echo "$file" | sed -e "s/^.//; s/.\$//;"`"
echo "Got request for: ${file}" >&2
if [ -d "www/$file" ]; then file="${file}/index.html"; fi
if [ -f "www/$file" ]; then
  ext="`echo "$file" | sed -e "s/.*\.//;"`"
  echo "HTTP/1.1 200 OK"
  echo "Server: bash+nc+sed+grep+openssl"
  cgi="`sed -n -e "/^$ext:/I{s/.*: //;p;q;}" httpd_cgi`"
  if [ "$cgi" = "" ]; then
    sed -n -e "/^${ext}:/I{s/.*: /Content-type: /;p;q;}" httpd_metadata
    echo "Connection: close"
    echo "Content-length: `du -b "www/${file}" | sed -e "s/[ \t].*//;"`"
    echo ""
    cat "www/${file}"
  else
    # CGI
    export SERVER_PROTOCOL="$protocol"
    export SERVER_PORT="8000"
    export PATH_INFO="$file"
    export PATH_TRANSLATED="www/${file}"
    export SERVER_SOFTWARE="bash+nc+sed+grep+openssl"
    export SERVER_NAME=""
    export GATEWAY_INTERFACE="CGI/1.1"
    export REDIRECT_STATUS=200
    export REQUEST_METHOD="$method"
    export QUERY_STRING="$query_string"
    export SCRIPT_NAME="${file}"
    export SCRIPT_FILENAME="www/${file}"
    export CONTENT_TYPE="`echo "$headers" | sed -n -e "/^content-type:/I{s/^content-type: *//I;p;q;}"`"
    export CONTENT_LENGTH="`echo "$headers" | sed -n -e "/^content-length:/I{s/^content-length: *//I;p;q;}"`"
    ${cgi} # stdin=POST data
  fi
else
  echo "www/$file doesn't exist" >&2
  echo "HTTP/1.1 404 File not found"
  echo "Server: bash+nc+sed+grep+openssl"
  echo "Content-type: text"
  echo "Connection: close"
  echo "Content-length: `du -b 404 | sed -e "s/[ \t].*//;"`"
  echo ""
  cat 404
fi
